package com.isu.gaswellwatch.dto;

import jakarta.validation.constraints.NotNull;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

/**
 * 设备对象 Device
 * 
 * @author scwsl
 * @date 2024-11-17
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class DeviceEditDTO implements Serializable {

    private static final long serialVersionUID = 1L;

    /** 主键 */
    @NotNull(message = "设备ID不能为空")
    private Long id;

    /** 集气站 */
    private String gasStation;

    /** 网关通讯地址 */
    private String gatewaySn;

    /** 描述 */
    private String details;



}
