package com.isu.gaswellwatch.modbus.data.decode.impl;

import com.isu.gaswellwatch.modbus.data.ModbusMessage;
import com.isu.gaswellwatch.modbus.data.decode.DecodeHandler;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Component;

import java.util.Map;

/**
 * 高低位4字节解析器
 *
 * @author <a href="mailto:scwsl@foxmail.com">王仕龙</a>
 * 2024/11/25 16:36
 */
@Component(HighLowBinDecodeHandler.NAME + DecodeHandler.DECODE_NAME)
public class HighLowBinDecodeHandler implements DecodeHandler {

    public static final String NAME = "highLowBin";

    @Override
    public String decode(Map<String, Object> commandPointMap, String value) {
        if (StringUtils.isBlank(value)) {
            return value;
        }
        return String.valueOf(Integer.parseInt(value, 16));
    }

    @Override
    public void decode(Map<String, Object> commandPointMap, ModbusMessage.MessagePoint point) {
        throw new RuntimeException("not supported");
    }

}
