package com.isu.gaswellwatch.thread;
import com.isu.gaswellwatch.entity.UserOperationRecord;
import com.isu.gaswellwatch.service.impl.UserOperationRecordServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.CollectionUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.TimerTask;
@Slf4j
public class AsyncLogTaskFactory {

    /**
     * 记录操作日志
     * @param operationLog 操作日志信息
     * @return 任务task
     */
    private  final UserOperationRecordServiceImpl operationRecordService;

    public AsyncLogTaskFactory(UserOperationRecordServiceImpl operationRecordService) {
        this.operationRecordService = operationRecordService;
    }

    public  TimerTask batchSaveRecord() {
        return new TimerTask() {
            @Override
            public void run() {
                // 进行日志持久化操作
                if(operationRecordService.CACHE.isEmpty()){
                    return;
                }
                List<UserOperationRecord> operationRecords = new ArrayList<>(UserOperationRecordServiceImpl.CACHE_BASE_CAPACITY);
                try {
                    for (int i = 1; i <= UserOperationRecordServiceImpl.CACHE_BASE_CAPACITY; i++) {
                        if (operationRecordService.CACHE.isEmpty()) {
                            break;
                        }
                        operationRecords.add(operationRecordService.CACHE.poll());
                    }
                    if(CollectionUtils.isEmpty(operationRecords)){
                        return;
                    }
                    operationRecordService.saveBatch(operationRecords);
                    log.info("操作记录处理程序开始执行入库，本次入库条数：{}", operationRecords.size());
                }catch (Exception e) {
                    e.printStackTrace();
                }
            }
        };
    }


}

