package com.isu.gaswellwatch.thread;


import cn.hutool.extra.spring.SpringUtil;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;

import java.util.TimerTask;

public class AsyncLogThreadPoolManager {
    /**
     * 单例模式，确保类只有一个实例
     */
    private AsyncLogThreadPoolManager() {
    }

    /**
     * 饿汉式，在类加载的时候立刻进行实例化
     */
    private static final AsyncLogThreadPoolManager INSTANCE = new AsyncLogThreadPoolManager();

    public static AsyncLogThreadPoolManager getInstance() {
        return INSTANCE;
    }

    /**
     * 异步操作任务调度线程池
     */
    private final ThreadPoolTaskExecutor executor = SpringUtil.getBean("threadPoolTaskExecutor", ThreadPoolTaskExecutor.class);

    /**
     * 执行任务
     *
     * @param task 任务
     */
    public void execute(TimerTask task) {
        executor.execute(task);
    }


}
